#!/bin/bash
#
# /home/eric/bin/ecamynthes/ecanoscl-i.sh
# eric@zhevny.com
#
# requires jack to have been started in another console (works as
# normal user since realtime lsm is loaded):
# jackd -v -R -d alsa -d ice1712 -r 48000 -p 512 -n2
#
# after ecanoscl-i.sh has been started ecanoscl-r.sh should be 
# started in a 3rd console if a recording is desired
# 
# FIXME: -this should be a .ecs file. is .ecs parsing broken? 
#          or am I (more likely) writing it wrong?
#        -generates a lot of xruns reported by ecasound's
#          (audioio-rtnull), but not by jackd. not surprisingly xrun 
#          count changes inversely to buffer size. i.e. if b=buffersize 
#          2b yields roughly .5 * (xruns at b).
#          with -t set to 60s in ecanoscl-r.sh
#          with b=2048 xrun count is consistently 1403
#          with b=1024 xrun count varied over 4 runs: 2450, 2639, 2807 twice 
#          with b=512 xrun count varied over 4 runs: 5429, 5433, 5454, 5616
#        -if -t:secs option is set in this script to limit runtime, this 
#          script gets kicked out of the jack graph when ecanoscl-r.sh 
#          is started. is this just not legal? do both ecasounds try to
#          be jack transport master or something?
#        -ecanoscl-r.sh allways exits with a segfault and takes ecanoscl-i.sh 
#          down with it.
#        -ecasound shouldn't need jack for this. There is something about
#          alsahw vs. alsaplugin vs. alsapcm and audio formats and .asoundrc
#          I'm not understanding or using correctly.
#        -ecasound should be able to generate the audio and write to
#          a file in one invocation with doubled up chains. for some
#          reason this didn't work when tried from the commandline
#          maybe there's an ecasound bug ... more likely I messed up
#        -zipper noise when -ea: -km's midi controller is used
#        -audio glitches in analogueOsc output. xrun-related?
#        -add controls for warm, instability and waveform
#        -add interpolation to analogueOsc Hz port

ecasound -b:512 -f:32,1,48000 \
         -a:1,2,3,4,5,6,7,8 -i:rtnull \
         -a:1,2,3,4,5,6,7,8 -o:jack_alsa \
         -a:1 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,9,1 -ea:0 -km:1,0,200,17,1 \
         -a:2 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,10,1 -ea:0 -km:1,0,200,18,1 \
         -a:3 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,11,1 -ea:0 -km:1,0,200,19,1 \
         -a:4 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,12,1 -ea:0 -km:1,0,200,20,1 \
         -a:5 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,13,1 -ea:0 -km:1,0,200,21,1 \
         -a:6 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,14,1 -ea:0 -km:1,0,200,22,1 \
         -a:7 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,15,1 -ea:0 -km:1,0,200,23,1 \
         -a:8 -el:analogueOsc,1,0,0,0,0 -km:2,1,1000,16,1 -ea:0 -km:1,0,200,24,1
